import bpy
import os


#print(bpy.context.active_pose_bone.name)
#print(bpy.context.active_object.vertex_groups.active_index)

class BoneGetter(bpy.types.Operator):
    """Tooltip"""
    bl_idname = "object.get_bone"
    bl_label = "Get Name of Bone"

    def execute(self, context):
        print(bpy.context.active_object.vertex_groups.active_index)
        return {'FINISHED'}

class AddBone(bpy.types.Operator):
    bl_idname='object.add_bone'
    bl_label = 'Add Vertex Group to Bone'
    
    def execute(self, context):
        bpy.ops.ed.undo_push()
        body = bpy.context.active_object
        
        index = 0
        create = True
        while (index < len(body.vertex_groups)):
            print('searching if bone exists: '+ body.vertex_groups[body.vertex_groups.active_index].name) 
            if (bpy.context.active_pose_bone.name == body.vertex_groups[index].name):
                print('bones '+  bpy.context.active_pose_bone.name +' and '+ body.vertex_groups[body.vertex_groups.active_index].name+ 'marked for combining')
                create = False
                break
            index +=1
        
        #have to create mixer modifier before adding vertex group or else the active vertex group will change to the new one
        print('create mixer modifier')
        mixer = body.modifiers.new(type='VERTEX_WEIGHT_MIX', name='mixer_mod')
        print('adding bone group b:', body.vertex_groups[body.vertex_groups.active_index].name)
        mixer.vertex_group_b = body.vertex_groups[body.vertex_groups.active_index].name
        
        if create:
            index = body.vertex_groups.active_index
            print('creating vertex group:', bpy.context.active_pose_bone.name)
            body.vertex_groups.new(name=bpy.context.active_pose_bone.name)
            print('created_new')
            body.vertex_groups.active_index = index
            
        print('adding bone group a:' ,bpy.context.active_pose_bone.name)
        mixer.vertex_group_a = bpy.context.active_pose_bone.name
        
        mixer.mix_mode = 'ADD'
        mixer.mix_set = 'OR'
        
        print('applying mixer mod modifier')
        bpy.ops.object.modifier_apply(modifier = 'mixer_mod')
        
                
        print(body.vertex_groups.active_index)
        print(body.vertex_groups[0].name)
        return {'FINISHED'}



class HelloWorldPanel(bpy.types.Panel):
    """Creates a Panel in the Object properties window"""
    bl_label = "Weight Mover"
    bl_idname = "OBJECT_PT_hello"
    bl_space_type = 'PROPERTIES'
    bl_region_type = 'WINDOW'
    bl_context = "object"

    def draw(self, context):
        layout = self.layout

        obj = context.object
        
        row = layout.row()
        row.operator('object.add_bone')
        
        row = layout.row()
        row.operator("object.remove_bone")






def register():
    bpy.utils.register_class(BoneGetter)
    bpy.utils.register_class(AddBone)
    bpy.utils.register_class(HelloWorldPanel)
    


def unregister():
    bpy.utils.unregister_class(BoneGetter)
    bpy.utils.unregister_class(AddBone)
    bpy.utils.unregister_class(HelloWorldPanel)


if __name__ == "__main__":
    register()
